package com.muyu.vehicleGateway;

import com.aliyun.ecs20140526.models.DescribeInstancesRequest;
import com.aliyun.ecs20140526.models.DescribeInstancesResponse;
import com.aliyun.ecs20140526.models.DescribeInstancesResponseBody;
import com.aliyun.tea.TeaException;
import com.aliyun.teautil.models.RuntimeOptions;
import lombok.extern.log4j.Log4j2;
import org.springframework.beans.factory.DisposableBean;
import org.springframework.stereotype.Component;

import java.util.ArrayList;

/**
 * 清除阿里云ECS实例
 * @ClassName ClearInstance
 * @author LiHD
 * @Date 2024/9/28 22:29
 */
@Component
@Log4j2
public class ClearInstance implements DisposableBean {

    /**
     * <b>description</b> :
     * <p>使用AK&amp;SK初始化账号Client</p>
     * @return Client
     *
     * @throws Exception
     */
    public static com.aliyun.ecs20140526.Client createClient() throws Exception {
        // 工程代码泄露可能会导致 AccessKey 泄露，并威胁账号下所有资源的安全性。以下代码示例仅供参考。
        // 建议使用更安全的 STS 方式，更多鉴权访问方式请参见：https://help.aliyun.com/document_detail/378657.html。
        com.aliyun.teaopenapi.models.Config config = new com.aliyun.teaopenapi.models.Config()
                // 必填，请确保代码运行环境设置了环境变量 ALIBABA_CLOUD_ACCESS_KEY_ID。
                .setAccessKeyId("LTAI5tM4LSerzWQ9wUPXgybq")
                // 必填，请确保代码运行环境设置了环境变量 ALIBABA_CLOUD_ACCESS_KEY_SECRET。
                .setAccessKeySecret("hkiPr0QwkKMZauhXucgg1SDriXUW0Q");
        // Endpoint 请参考 https://api.aliyun.com/product/Ecs
        config.endpoint = "ecs.cn-beijing.aliyuncs.com";
        return new com.aliyun.ecs20140526.Client(config);
    }

    public static void clearInstance() throws Exception {

        // 创建ECS客户端对象，用于后续调用ECS相关API
        com.aliyun.ecs20140526.Client client = ClearInstance.createClient();

        DescribeInstancesRequest describeInstancesRequest = new DescribeInstancesRequest()
                .setRegionId("cn-beijing");

        //创建运行时选择对象,用于配置运行时的选项参数
        RuntimeOptions runtimeOptions = new RuntimeOptions();

        //获取实例列表
        DescribeInstancesResponse describeInstancesResponse = client.describeInstancesWithOptions(describeInstancesRequest, runtimeOptions);

        //提取实例ID集合
        ArrayList<String> list = new ArrayList<>();
        DescribeInstancesResponseBody body = describeInstancesResponse.getBody();

        for (DescribeInstancesResponseBody.DescribeInstancesResponseBodyInstancesInstance instance : body.getInstances().getInstance()) {
            list.add(instance.getInstanceId());
        }
        log.info("Instance IDs: " + list);
        // 创建删除实例请求对象，并设置请求参数
        com.aliyun.ecs20140526.models.DeleteInstancesRequest deleteInstancesRequest = new com.aliyun.ecs20140526.models.DeleteInstancesRequest()
                // 设置地域ID，指定删除实例的地域
                .setRegionId("cn-beijing")
                // 设置DryRun为true，用于验证请求是否可以成功，但不实际执行删除操作
                .setDryRun(false)
                // 设置Force为true，表示即使实例有正在运行的任务，也强制删除实例
                .setForce(true)
                // 设置TerminateSubscription为true，表示删除按订阅付费的实例时终止订阅
                .setTerminateSubscription(true)
                .setInstanceId(list);

        // 创建运行时选项对象，用于配置运行时的选项参数
        com.aliyun.teautil.models.RuntimeOptions runtime = new com.aliyun.teautil.models.RuntimeOptions();
        try {
            // 复制代码运行请自行打印 API 的返回值
            client.deleteInstancesWithOptions(deleteInstancesRequest, runtime);
        } catch (TeaException error) {
            // 此处仅做打印展示，请谨慎对待异常处理，在工程项目中切勿直接忽略异常。
            // 错误 message
            System.out.println(error.getMessage());
            // 诊断地址
            System.out.println(error.getData().get("Recommend"));
            com.aliyun.teautil.Common.assertAsString(error.message);
        } catch (Exception _error) {
            TeaException error = new TeaException(_error.getMessage(), _error);
            // 此处仅做打印展示，请谨慎对待异常处理，在工程项目中切勿直接忽略异常。
            // 错误 message
            System.out.println(error.getMessage());
            // 诊断地址
            System.out.println(error.getData().get("Recommend"));
            com.aliyun.teautil.Common.assertAsString(error.message);
        }
    }


    @Override
    public void destroy() throws Exception {
        log.info("开始执行删除实例方法");
        clearInstance();
        log.info("删除实例方法执行完毕");
    }
}
